grammar SimpleLog;

/*----------------
* PARSER RULES
*----------------*/

log		:	trace+;
trace		:	numtraces? events;
events		:	event (COMMA event)* SEMICOLON ;
numtraces	:	INT;
event		:	ID;
 

/*----------------
* LEXER RULES
*----------------*/

COMMA		:	',';
SEMICOLON	:	';';
ID		:	('a'..'z'|'A'..'Z') ('a'..'z'|'A'..'Z'|'0'..'9'|'-'|'_')*;
INT     	:	[0-9]+;
NEWLINE 	:	'\r'?'\n' -> skip ;
WS 		:	(' '|'\t'|'\n'|'\r'|'\u000C')+ -> skip ;


