package com.processmininguc.slog.plugins;

import java.io.InputStream;

import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.annotations.UIImportPlugin;
import org.processmining.framework.abstractplugins.AbstractImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;

import com.processmininguc.slog.parser.SimpleLogUtils;

@Plugin(name = "Import Log from SimpleLog file", parameterLabels = { "Filename" }, returnLabels = { "Log" }, returnTypes = { XLog.class })
@UIImportPlugin(description = "SimpleLog files", extensions = { "slog" })
public class ImportSimpleLogPlugin extends AbstractImportPlugin {

	protected FileFilter getFileFilter() {
		return new FileNameExtensionFilter("SimpleLog files", "slog");
	}

	protected Object importFromStream(PluginContext context, InputStream input, String filename, long fileSizeInBytes)
			throws Exception {
		return SimpleLogUtils.parse(input);
	}
}

