grammar SimpleResourceLog;

/*----------------
* PARSER RULES
*----------------*/

log			:	trace+;
trace		:	numtraces? events;
events		:	event (COMMA event)* SEMICOLON ;
numtraces	:	INT;
event		:	activity LPAR resource RPAR;
activity	:	ID;
resource	:   ID;
 

/*----------------
* LEXER RULES
*----------------*/

LPAR		:	'(';
RPAR		:	')';
COMMA		:	',';
SEMICOLON	:	';';
ID		:	('a'..'z'|'A'..'Z') ('a'..'z'|'A'..'Z'|'0'..'9'|'-'|'_')*;
INT     	:	[0-9]+;
NEWLINE 	:	'\r'?'\n' -> skip ;
WS 		:	(' '|'\t'|'\n'|'\r'|'\u000C')+ -> skip ;


