package com.processmininguc.srlog.parser;

import java.io.IOException;
import java.io.InputStream;

import org.antlr.v4.runtime.ANTLRInputStream;
import org.antlr.v4.runtime.CommonTokenStream;
import org.antlr.v4.runtime.tree.ParseTree;
import org.antlr.v4.runtime.tree.ParseTreeWalker;
import org.deckfour.xes.model.XLog;

public class SimpleResourceLogUtils {
	
	public static XLog parse (String text){
		ANTLRInputStream input = new ANTLRInputStream(text);
		return parse(input);	
	}
	
	public static XLog parse (InputStream text) throws IOException{
		ANTLRInputStream input = new ANTLRInputStream(text);
		return parse(input);
	}
	
	private static XLog parse (ANTLRInputStream input){
		SimpleResourceLogLexer lexer = new SimpleResourceLogLexer(input);
	    CommonTokenStream tokens = new CommonTokenStream(lexer);
	    SimpleResourceLogParser parser = new SimpleResourceLogParser(tokens);
	    ParseTree tree = parser.log();
	    ParseTreeWalker walker = new ParseTreeWalker();
	    SimpleResourceLogRecognizer recognizer = new SimpleResourceLogRecognizer();
	    walker.walk(recognizer, tree);
	    return recognizer.getLog();
	}

}
