package com.processmininguc.srlog.plugins;

import java.io.InputStream;

import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.annotations.UIImportPlugin;
import org.processmining.framework.abstractplugins.AbstractImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;

import com.processmininguc.srlog.parser.SimpleResourceLogUtils;

@Plugin(name = "Import Log from SimpleResourceLog file", parameterLabels = { "Filename" }, returnLabels = { "Log" }, returnTypes = { XLog.class })
@UIImportPlugin(description = "SimpleResourceLog files", extensions = { "srlog" })
public class ImportSimpleResourceLogPlugin extends AbstractImportPlugin {

	protected FileFilter getFileFilter() {
		return new FileNameExtensionFilter("SimpleResourceLog files", "srlog");
	}

	protected Object importFromStream(PluginContext context, InputStream input, String filename, long fileSizeInBytes)
			throws Exception {
		return SimpleResourceLogUtils.parse(input);
	}
}

