package com.processmininguc.srlog.plugins;

import info.clearthought.layout.TableLayout;
import info.clearthought.layout.TableLayoutConstants;

import javax.swing.JPanel;
import javax.swing.JTextArea;

import org.deckfour.uitopia.api.event.TaskListener.InteractionResult;
import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.framework.util.ui.widgets.ProMTextArea;

import com.processmininguc.srlog.parser.SimpleResourceLogUtils;

@Plugin(name = "Write SimpleResourceLog using Editor", parameterLabels = { "String" }, 
returnLabels = { "Log" }, returnTypes = { XLog.class })
public class WriteSimpleResourceLogUsingEditorPlugin {
	
	@UITopiaVariant(affiliation = "Pontificia Universidad Catolica de Chile", author = "J.Munoz-Gama", 
			email = "jmun"+ (char) 0x40 + "ing.puc.cl", website = "www.jorgemunozgama.com", 
			pack = "SLog")
	@PluginVariant(variantLabel = "Write SimpleResourceLog + UI", requiredParameterLabels = {})
	public XLog write(UIPluginContext context) {	
		
		JPanel dialog = new JPanel();
		double size[][] = { { TableLayoutConstants.FILL,200 }, { TableLayoutConstants.FILL} };
		dialog.setLayout(new TableLayout(size));
		
		JTextArea textArea = new JTextArea();  
		dialog.add(textArea, "0, 0");
		
		ProMTextArea format = new ProMTextArea();
		format.setText("10 a (ana), b (bob), c (bob); \n 2 a (carol), c (bob), d (ana); \n a (ana), d (bob);");
		dialog.add(format, "1,0");
		
		InteractionResult result = context.showWizard("SimpleResourceLog Editor", 
				true, true, dialog);
		if (result != InteractionResult.FINISHED) {
			return null;
		}
		
		return SimpleResourceLogUtils.parse(textArea.getText());
	}
	
	@PluginVariant(variantLabel = "Write SimpleResourceLog + String", requiredParameterLabels = {0})
	public XLog write(PluginContext context, String text) {		
		return SimpleResourceLogUtils.parse(text);
	}
		

}
