grammar TRLog;

/*----------------
* PARSER RULES
*----------------*/

log		    :	trace+;
trace		:	(numtraces WS)? events;
events		:	event (WS event)* NEWLINE ;
numtraces	:	INT;
event		:	ID;
 

/*----------------
* LEXER RULES
*----------------*/

COMMA		:	',';
SEMICOLON	:	';';
ID		    :	('a'..'z'|'A'..'Z') ('a'..'z'|'A'..'Z'|'0'..'9'|'-'|'_')*;
INT     	:	[0-9]+;
NEWLINE 	:	'\r'?'\n';
WS 		    :	(' '|'\t'|'\n'|'\r'|'\u000C')+;


