package com.processmininguc.trlog.plugins;

import java.io.InputStream;

import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.annotations.UIImportPlugin;
import org.processmining.framework.abstractplugins.AbstractImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;

import com.processmininguc.trlog.parser.TRLogUtils;

@Plugin(name = "Import Log from TRLog file", parameterLabels = { "Filename" }, returnLabels = { "Log" }, returnTypes = { XLog.class })
@UIImportPlugin(description = "TRLog files", extensions = { "tr" })
public class ImportTRLogPlugin extends AbstractImportPlugin {

	protected FileFilter getFileFilter() {
		return new FileNameExtensionFilter("TRLog files", "tr");
	}

	protected Object importFromStream(PluginContext context, InputStream input, String filename, long fileSizeInBytes)
			throws Exception {
		return TRLogUtils.parse(input);
	}
}

